class AcidSynthLearnedBiquadCoeff(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  ac : __torch__.audio_config.AudioConfig
  interp_logits : bool
  is_scriptable : bool
  vco : __torch__.acid_ddsp.synth_modules.SquareSawVCOLite
  env_gen : __torch__.acid_ddsp.synth_modules.ExpDecayEnv
  def forward(self: __torch__.synths.AcidSynthLearnedBiquadCoeff,
    n_samples: int,
    f0_hz: Tensor,
    note_on_duration: Tensor,
    phase: Tensor,
    filter_args: Dict[str, Tensor],
    global_params: Dict[str, Tensor],
    envelope: Optional[Tensor]=None) -> Dict[str, Tensor]:
    osc_shape = torch.get(global_params, "osc_shape")
    if torch.__is__(osc_shape, None):
      ac = self.ac
      if (ac).is_fixed("osc_shape", ):
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
      ac0 = self.ac
      min_osc_shape = ac0.min_osc_shape
      osc_shape1 = torch.full_like(f0_hz, min_osc_shape)
      osc_shape0 = osc_shape1
    else:
      osc_shape0 = unchecked_cast(Tensor, osc_shape)
    osc_gain = torch.get(global_params, "osc_gain")
    if torch.__is__(osc_gain, None):
      ac1 = self.ac
      if (ac1).is_fixed("osc_gain", ):
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
      ac2 = self.ac
      min_osc_gain = ac2.min_osc_gain
      osc_gain1 = torch.full_like(f0_hz, min_osc_gain)
      osc_gain0 = osc_gain1
    else:
      osc_gain0 = unchecked_cast(Tensor, osc_gain)
    dist_gain = torch.get(global_params, "dist_gain")
    if torch.__is__(dist_gain, None):
      ac3 = self.ac
      if (ac3).is_fixed("dist_gain", ):
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
      ac4 = self.ac
      min_dist_gain = ac4.min_dist_gain
      dist_gain1 = torch.full_like(f0_hz, min_dist_gain)
      dist_gain0 = dist_gain1
    else:
      dist_gain0 = unchecked_cast(Tensor, dist_gain)
    learned_alpha = torch.get(global_params, "learned_alpha")
    if torch.__is__(learned_alpha, None):
      ac5 = self.ac
      if (ac5).is_fixed("learned_alpha", ):
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
      ac6 = self.ac
      min_learned_alpha = ac6.min_learned_alpha
      learned_alpha1 = torch.full_like(f0_hz, min_learned_alpha)
      learned_alpha0 = learned_alpha1
    else:
      learned_alpha2 = unchecked_cast(Tensor, learned_alpha)
      learned_alpha0 = learned_alpha2
    _0 = torch.eq(torch.size(note_on_duration), torch.size(osc_shape0))
    if _0:
      _2 = torch.eq(torch.size(osc_shape0), torch.size(osc_gain0))
      _1 = _2
    else:
      _1 = False
    if _1:
      _4 = torch.eq(torch.size(osc_gain0), torch.size(dist_gain0))
      _3 = _4
    else:
      _3 = False
    if _3:
      _6 = torch.eq(torch.size(dist_gain0), torch.size(learned_alpha0))
      _5 = _6
    else:
      _5 = False
    if _5:
      pass
    else:
      ops.prim.RaiseException("AssertionError: ")
    vco = self.vco
    dry_audio = (vco).forward(f0_hz, osc_shape0, n_samples, phase, )
    dry_audio0 = torch.mul_(dry_audio, torch.unsqueeze(osc_gain0, -1))
    if torch.__is__(envelope, None):
      env_gen = self.env_gen
      envelope1 = (env_gen).forward(learned_alpha0, note_on_duration, n_samples, )
      envelope0 = envelope1
    else:
      envelope0 = unchecked_cast(Tensor, envelope)
    dry_audio1 = torch.mul_(dry_audio0, envelope0)
    _7 = (self).filter_dry_audio(dry_audio1, filter_args, )
    filtered_audio, filter_out, = _7
    wet_audio = torch.mul(filtered_audio, torch.unsqueeze(dist_gain0, -1))
    wet_audio0 = torch.tanh(wet_audio)
    synth_out = {"dry": dry_audio1, "wet": wet_audio0, "envelope": envelope0, "filtered_audio": filtered_audio}
    torch.update(synth_out, filter_out)
    return synth_out
  def filter_dry_audio(self: __torch__.synths.AcidSynthLearnedBiquadCoeff,
    x: Tensor,
    filter_args: Dict[str, Tensor]) -> Tuple[Tensor, Dict[str, Tensor]]:
    _8 = __torch__.filters.sample_wise_lpc_scriptable
    logits = filter_args["logits"]
    if torch.eq(torch.dim(logits), 3):
      pass
    else:
      ops.prim.RaiseException("AssertionError: ")
    n_samples = torch.size(x, 1)
    _9 = (self)._calc_coeff(logits, n_samples, )
    a_coeff, b_coeff, = _9
    zi = torch.get(filter_args, "zi")
    if torch.__isnot__(zi, None):
      zi_a0 = unchecked_cast(Tensor, zi)
      zi_a : Optional[Tensor] = torch.flip(zi_a0, [1])
    else:
      zi_a = zi
    y_a = _8(x, a_coeff, zi_a, )
    _10 = torch.__not__(bool(torch.any(torch.isinf(y_a))))
    if _10:
      pass
    else:
      ops.prim.RaiseException("AssertionError: ")
    _11 = torch.__not__(bool(torch.any(torch.isnan(y_a))))
    if _11:
      pass
    else:
      ops.prim.RaiseException("AssertionError: ")
    y_ab = __torch__.filters.time_varying_fir(y_a, b_coeff, zi, )
    _12 = torch.slice(torch.slice(a_coeff), 1)
    a1 = torch.select(_12, 2, 0)
    _13 = torch.slice(torch.slice(a_coeff), 1)
    a2 = torch.select(_13, 2, 1)
    a0 = torch.ones_like(a1)
    a_coeff0 = torch.stack([a0, a1, a2], 2)
    filter_out = {"a_coeff": a_coeff0, "b_coeff": b_coeff, "y_a": y_a}
    return (y_ab, filter_out)
  def _calc_coeff(self: __torch__.synths.AcidSynthLearnedBiquadCoeff,
    logits: Tensor,
    n_frames: int) -> Tuple[Tensor, Tensor]:
    _14 = __torch__.util.linear_interpolate_dim
    _15 = __torch__.filters.calc_logits_to_biquad_a_coeff_triangle
    if torch.eq(torch.dim(logits), 3):
      pass
    else:
      ops.prim.RaiseException("AssertionError: ")
    bs = torch.size(logits, 0)
    interp_logits = self.interp_logits
    if interp_logits:
      logits1 = _14(logits, n_frames, 1, True, )
      _16 = torch.eq(torch.size(logits1), [bs, n_frames, 5])
      if _16:
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
      logits0 = logits1
    else:
      logits0 = logits
    a_logits = torch.slice(logits0, -1, None, 2)
    ac = self.ac
    stability_eps = ac.stability_eps
    a_coeff = _15(a_logits, stability_eps, )
    b_coeff = torch.slice(logits0, -1, 2)
    interp_logits0 = self.interp_logits
    if torch.__not__(interp_logits0):
      a_coeff2 = _14(a_coeff, n_frames, 1, True, )
      _17 = torch.eq(torch.size(a_coeff2), [bs, n_frames, 2])
      if _17:
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
      b_coeff1 = _14(b_coeff, n_frames, 1, True, )
      _18 = torch.eq(torch.size(b_coeff1), [bs, n_frames, 3])
      if _18:
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
      a_coeff1, b_coeff0 = a_coeff2, b_coeff1
    else:
      a_coeff1, b_coeff0 = a_coeff, b_coeff
    return (a_coeff1, b_coeff0)
